Graphics 512,512,32,2
SetBuffer BackBuffer()
;=================================
;Das hier ist auch zum Weiterverwenden notwendig:
Global ImageList=Create(ImageList)
;=================================
Local File=ReadFile("Test.ini")

Local Image

If File=0
	Image=LoadImage2("Beispiel.png")
Else
	;Beispiel fr das Laden von z.B. Spielstnden
	Image=Int(ReadLine(File))
	Load(ImageList,ImageList,File,"")
	CloseFile File
	ReloadImages()
	;
EndIf
Repeat
	Cls
	
	DrawImage2 Image,Sin(MilliSecs()/10.0)*100,Cos(MilliSecs()/10.0)*100
	If GetKey()<>0 Then Graphics 256,256,32,2:SetBuffer BackBuffer():ReloadImages();Man kann mit diesen Funktionen ohne Neustart die Auflsung ndern!
	
	Flip
Until KeyHit(1)
;Beispiel fr das Speichern
File=WriteFile("Test.ini")
WriteLine File,Image;Die ID des Bildes muss nach dem Laden bekannt sein, um das Bild nutzen zu knnen.
Save(ImageList,ImageList,File)
;
End



;=========================================================================
;Ab hier fangen die allgemeinen Funktionen an.
;=========================================================================


Function LoadImage2(File$,Mode=1)
	Local Image=LoadImage(File$)
;	Local Image=LoadImage(File$,Mode)	;B+
	If Image=0 Then Return -1
	Local Offset
	Local Width=ImageWidth(Image)
	Local Height=ImageHeight(Image)
	Local FirstFr=0
	Local Count=1
	For Offset=EachIn(ImageList,ImageList);Gibt es einen Eintrag ohne geladenes Image? Wenn ja, dann werden die neuen Daten in diesem Eintrag abgespeichert.
		If Peek(ImageList,ImageList,Image,Offset)=0
			Poke(ImageList,ImageList,Image,Image,Offset)
			
			Poke(ImageList,ImageList,File  ,File$  ,Offset)
			Poke(ImageList,ImageList,Width ,Width  ,Offset)
			Poke(ImageList,ImageList,Height,Height ,Offset)
			Poke(ImageList,ImageList,First ,FirstFr,Offset)
			Poke(ImageList,ImageList,Count ,Count  ,Offset)
			Poke(ImageList,ImageList,Mode  ,Mode   ,Offset)
			Return GetID(ImageList,Offset)
		EndIf
	Next
	Offset=Offset(ImageList,Countentries(ImageList,ImageList))
	Add(ImageList,ImageList);Sonst wird ein neuer Eintrag erstellt.
	Poke(ImageList,ImageList,Image,Image,Offset)
	
	Poke(ImageList,ImageList,File  ,File$  ,Offset)
	Poke(ImageList,ImageList,Width ,Width  ,Offset)
	Poke(ImageList,ImageList,Height,Height ,Offset)
	Poke(ImageList,ImageList,First ,FirstFr,Offset)
	Poke(ImageList,ImageList,Count ,Count  ,Offset)
	Poke(ImageList,ImageList,Mode  ,Mode   ,Offset)
	Return GetID(ImageList,Offset)
End Function

Function LoadAnimImage2(File$,Width,Height,FirstFr,Count,Mode=1)
	Local Image=LoadAnimImage(File$,Width,Height,FirstFr,Count)
;	Local Image=LoadAnimImage(File$,Width,Height,FirstFr,Count,Mode)	;B+
	If Image=0 Then Return -1
	Local Offset
	For Offset=EachIn(ImageList,ImageList);Gibt es einen Eintrag ohne geladenes Image? Wenn ja, dann werden die neuen Daten in diesem Eintrag abgespeichert.
		If Peek(ImageList,ImageList,Image,Offset)=0
			Poke(ImageList,ImageList,Image,Image,Offset)
			
			Poke(ImageList,ImageList,File  ,File$  ,Offset)
			Poke(ImageList,ImageList,Width ,Width  ,Offset)
			Poke(ImageList,ImageList,Height,Height ,Offset)
			Poke(ImageList,ImageList,First ,FirstFr,Offset)
			Poke(ImageList,ImageList,Count ,Count  ,Offset)
			Poke(ImageList,ImageList,Mode  ,Mode   ,Offset)
			Return GetID(ImageList,Offset)
		EndIf
	Next
	Offset=Offset(ImageList,Countentries(ImageList,ImageList))
	Add(ImageList,ImageList);Sonst wird ein neuer Eintrag erstellt.
	Poke(ImageList,ImageList,Image,Image,Offset)
	
	Poke(ImageList,ImageList,File  ,File$  ,Offset)
	Poke(ImageList,ImageList,Width ,Width  ,Offset)
	Poke(ImageList,ImageList,Height,Height ,Offset)
	Poke(ImageList,ImageList,First ,FirstFr,Offset)
	Poke(ImageList,ImageList,Count ,Count  ,Offset)
	Poke(ImageList,ImageList,Mode  ,Mode   ,Offset)
	Return GetID(ImageList,Offset)
End Function

Function FreeImage2(Image)
	FreeImage Get(ImageList,ImageList,Image,Image)
	Set(ImageList,ImageList,Image,0,Image);Ein Wert von "0" bedeutet, dass dieser Eintrag keinem Bild mehr angehrt und berschrieben werden kann.
End Function

Function FreeAllImages(Remove=1)
	Local Offset
	For Offset=EachIn(ImageList,ImageList)
		If Peek(ImageList,ImageList,Image,Offset)<>0
			FreeImage Peek(ImageList,ImageList,Image,Offset)
		EndIf
	Next
	If Remove
		Remove(ImageList,ImageList,0,CountEntries(ImageList,ImageList))
	EndIf
End Function

Function ReloadImages()
	Local Offset
	Local File$,Width,Height,FirstFr,Count,Mode,Image
	For Offset=EachIn(ImageList,ImageList)
		If Peek(ImageList,ImageList,Image,Offset)<>0
			File$	=Peek(ImageList,ImageList,File	,Offset)
			Width	=Peek(ImageList,ImageList,Width	,Offset)
			Height	=Peek(ImageList,ImageList,Height,Offset)
			FirstFr	=Peek(ImageList,ImageList,First	,Offset)
			Count	=Peek(ImageList,ImageList,Count	,Offset)
			Mode	=Peek(ImageList,ImageList,Mode	,Offset)
			
			Image=LoadAnimImage(File$,Width,Height,FirstFr,Count)
;			Image=LoadAnimImage(File$,Width,Height,FirstFr,Count,Mode)	;B+
			Poke(ImageList,ImageList,Image,Image,Offset)
		EndIf
	Next
End Function

Function GetImage(Image)
	Return Get(ImageList,ImageList,Image,Image)
End Function

Function DrawImage2(Image,x,y,Frame=0)
	DrawImage Get(ImageList,ImageList,Image,Image),x,y,Frame
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D